
int curstartwin;
FONT *labelfont;
char startdir[150];
int submenuflag;	//flag if a user clicks submenu in start menu : 1 is true - 0 is false
int startcnt;

typedef struct startcuts STARTCUTS;
struct startcuts{
        int used;
	int isfile;
        char caption[30];
	char filename[100];
	char linkfile[100];
	char icon[100];
};
STARTCUTS start[150];


typedef struct startwins STARTWINS;
struct startwins{
        int used;
	int winid;
};
STARTWINS startwin[6];

void closeallstartwins();
void dostartmenu(int data);
void dostartmenu2(int data);

void initstartmenu()
{
	curstartwin=0;
	closeallstartwins();
	memset(startdir,0,sizeof(startdir));
	strcpy(startdir,"system\\shortcuts");
	startcnt=0;
}

void dostartmenu(int data)
{
	initstartmenu();
	dostartmenu2(0);
}

void newstartdir(int data)
{
	//CloseWin(startwin);
	memset(startdir,0,sizeof(startdir));
	strcpy(startdir,start[data].filename);
	dostartmenu2(0);
}

void closestartwin(int winid)
{
	int t;
	int w;
	w=startwin[winid].winid;
	if(startwin[winid].used==1)
	{
		t=strcmp(guiwin[w].caption,"GUI_DLL_STARTWIN");
		if(t==0)
			CloseWin(startwin[winid].winid);
		startwin[winid].used=0;
	}
}

void closeallstartwins()
{
	int cnt;
	int w;
	cnt=0;
	do{
		if(startwin[cnt].used==1)
		{
			w=startwin[cnt].winid;
			if(strcmp(guiwin[w].caption,"GUI_DLL_STARTWIN")==0)
				CloseWin(startwin[cnt].winid);
			startwin[cnt].used=0;
		}
		cnt++;
		if(cnt==5)
			return;
	}while(1);
}

void startlink(int data)
{
	//user clicked on a link shortcut instead of a subdir
	curstartwin=0;
	closeallstartwins();
	RunApp(start[data].filename);
}

void dostartmenu2(int data)
{
	//here we'll create a menuwin and blit bgwin onto it
	struct ffblk f;
	FILE *f1;
	char fbuff;
	FONT *startfont;
	char buff[100];
	char linktitle[100];
	char readline[100];
	int done;
	int clickedwin;
	int filecnt;
	int startwinh;
	int x;
	int y;
	BITMAP *bmp;
	BITMAP *winbmp;
	guiwhite=makecol(0xff,0xff,0xff);
	filecnt=0;
	memset(buff,0,sizeof(buff));
	strcpy(buff,startdir);
	strcat(buff,"\\*.*");
	done=findfirst(buff,&f,FA_DIREC);
	while(!done)
	{
		filecnt++;
		done=findnext(&f);
	}
	startwinh=(filecnt*20)-20;
	clickedwin=CurrentWindow();
	if(clickedwin==startwin[0].winid && startwin[0].used==1)
	{
		closestartwin(1);
		closestartwin(2);
		closestartwin(3);
		closestartwin(4);
		curstartwin=1;
	}
	if(clickedwin==startwin[1].winid && startwin[1].used==1)
	{
		closestartwin(2);
		closestartwin(3);
		closestartwin(4);
		curstartwin=2;
	}
	if(clickedwin==startwin[2].winid && startwin[2].used==1)
	{
		closestartwin(3);
		closestartwin(4);
		curstartwin=3;
	}
	if(clickedwin==startwin[3].winid && startwin[3].used==1)
	{
		closestartwin(4);
		curstartwin=4;
	}
	startwin[curstartwin].used=1;
startwin[curstartwin].winid=MakeMenuWindow(curstartwin*200,screen_h-30-startwinh-(curstartwin*(startwinh/2)),200,startwinh,"GUI_DLL_STARTWIN",BlankHandler,0);
	winbmp=GetWinBMP(startwin[curstartwin].winid);
	//now we add the list duh..
	memset(buff,0,sizeof(buff));
	strcpy(buff,startdir);
	strcat(buff,"\\*.*");

	x=33;
	if(curstartwin==0)
		x+=20;
	y=8;
	done=findfirst(buff,&f,FA_DIREC);
	while(!done)
	{
		strcpy(start[startcnt].filename,startdir);
		strcat(start[startcnt].filename,"\\");
		strcat(start[startcnt].filename,f.ff_name);
		strcpy(start[startcnt].caption,f.ff_name);
		start[startcnt].isfile=0;
		start[startcnt].used=1;
		if(strstr(f.ff_name,".LNK")==0 &&strcmp(f.ff_name,".")!=0 && strcmp(f.ff_name,"..")!=0)
		{
			bmp=load_bitmap("icons\\folder.bmp",0);	MakeLabelButton(startwin[curstartwin].winid,SystemFont(),x,y,0,start[startcnt].caption,newstartdir,startcnt);
			masked_stretch_blit(bmp,winbmp,0,0,bmp->w,bmp->h,x-25,y-5,20,20);
			destroy_bitmap(bmp);
			bmp=load_bitmap("icons\\submenu.bmp",0);
			masked_blit(bmp,winbmp,0,0,200-8,y+1,bmp->w,bmp->h);
			destroy_bitmap(bmp);
			y=y+20;
			startcnt++;
		}
		else if(strstr(f.ff_name,".LNK")!=0)
		{
			f1=fopen(start[startcnt].filename,"rt");
			memset(linktitle,0,sizeof(linktitle));
			fbuff=fgets(linktitle,100,f1);
			linktitle[strlen(linktitle)-1]=0;
			memset(readline,0,sizeof(readline));
			fbuff=fgets(readline,100,f1);
			memset(start[startcnt].filename,0,100);
			readline[strlen(readline)-1]=0;
			strcpy(start[startcnt].filename,readline);
			memset(readline,0,sizeof(readline));
			fbuff=fgets(readline,100,f1);
			readline[strlen(readline)-1]=0;
			bmp=load_bitmap(readline,0);
			fclose(f1);
MakeLabelButton(startwin[curstartwin].winid,SystemFont(),x,y,0,linktitle,startlink,startcnt);
			masked_stretch_blit(bmp,winbmp,0,0,bmp->w,bmp->h,x-25,y-5,20,20);
			destroy_bitmap(bmp);
			y=y+22;
			startcnt++;
		}
		done=findnext(&f);
	}
	if(curstartwin==0)
	{
		bmp=load_bitmap("system\\startside.bmp",0);
		stretch_blit(bmp,winbmp,0,0,bmp->w,bmp->h,1,1,bmp->w,winbmp->h-1);
		destroy_bitmap(bmp);
	}
	ShowWin(startwin[curstartwin].winid);
	SetFocusOn(startwin[curstartwin].winid);
	curstartwin++;
	memset(startdir,0,sizeof(startdir));
	strcpy(startdir,"system\\shortcuts");
}

